#ifdef _NES_MAPPER_CPP_

/////////////////////////////////////////////////////////////////////
// Mapper 254
void NES_mapper254::Reset()
{
	// set CPU bank pointers
	set_CPU_banks(0, 1, num_8k_ROM_banks-2, num_8k_ROM_banks-1);
	regs[0]=0;
	// set PPU bank pointers
	if(num_1k_VROM_banks)
	{
		set_PPU_banks(0,1,2,3,4,5,6,7);
	}
	irq_latch=irq_counter=irq_enabled=0;
}


void NES_mapper254::MemoryWriteSaveRAM(uint32 addr, uint8 data)
{
	//	if(addr>=0x6000 && addr < 0x8000){
//	parent_NES->WriteSaveRAM(0, 0);
	//    }
	LOG("W " << HEX(addr,4) << "  " << HEX(data,2)  << endl);
}


void NES_mapper254::MemoryReadSaveRAM(uint32 addr)
{
	LOG("R " << HEX(addr,4)  << endl);
}


void NES_mapper254::MemoryWrite(uint32 addr, uint8 data)
{
	//	char f=0;
	switch(addr/*&0xf001*/){
	case 0x8000:
		//			set_CPU_bank4(data);
		regs[0]=data;
		//			f=1;
		break;
	case 0x8001:
		switch(regs[0]&7){
		case 0:
			set_PPU_bank0(data);
			set_PPU_bank1(data+1);
			break;
		case 1:
			set_PPU_bank2(data);
			set_PPU_bank3(data+1);
			break;
		case 2:
			set_PPU_bank4(data);
			break;
		case 3:
			set_PPU_bank5(data);
			break;
		case 4:
			set_PPU_bank6(data);
			break;
		case 5:
			set_PPU_bank7(data);
			break;
		case 6:
			set_CPU_bank4(data);
			//					f=1;
			//					LOG("W6  " << HEX(addr,4) << "  " << HEX(data,2) << endl);
			break;
		case 7:
			set_CPU_bank5(data);
			//					f=1;
			//					LOG("W7  " << HEX(addr,4) << "  " << HEX(data,2) << endl);
			break;
		}
		break;
#if 1
	case 0x8800:
		break;
	case 0xA000:
		break;
	case 0xA001:
		irq_enabled=data;
		break;
	case 0xE000:
		irq_counter= (irq_counter&0xff00)|data;
		//			set_CPU_bank4(data);
		break;
	case 0xE001:
		irq_counter=(irq_counter&0xff)|(data<<8);
		//			set_CPU_bank5(data);
		break;
	if(addr>=0x8000 ){
		LOG("W " << HEX(addr,4) << "  " << HEX(data,2) << "  " << HEX(regs[0],2) << endl);
	}
#endif
	}
}

void NES_mapper254::HSync(uint32 scanline)
{
#if 0
	if(irq_enabled)
	{
		if(scanline<241 /*&& (parent_NES->ppu->spr_enabled() || parent_NES->ppu->bg_enabled())*/){
			irq_counter-=114;
			if(irq_counter<=0){
				parent_NES->cpu->DoIRQ();
				irq_enabled = 0;
				//			  irq_counter = irq_latch;
			}
		}
	}
#endif
}


/////////////////////////////////////////////////////////////////////

#endif
